#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "qpu2commandqueue4xi.py">
#<abstract4xi abstract = "QPU commandqueue management"/>
#<refer4xi reference = "commandqueue4xi.py"/>
#<verify4xi verification = "10" target = "qpu2commandqueue4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'QPU2CommandQueue4Xi',
            'create2commandqueue4qpu',
            'finish2commandqueue4qpu',
            'flush2commandqueue4qpu',
            'get2commandqueueinfo4qpu',
            'release2commandqueue4qpu',
            'retain2commandqueue4qpu',
            'set2commandqueue4qpu',
            'trace2commandqueue4qpu'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   

from decimal import *
#"
#/>

# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from qpu2context4xi import get2context4qpu
from qpu2device4xi import get2qpu4xi
from platformids4xi  import get2platformids4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from cpu_corecount4xi import cpu_corecount4xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                             
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global qpu2commandqueue4xi                                              # Commandqueue of QPU               
global qpu2buffer4xi                                                    # Buffer of QPU 
global qpu2trace4xi                                                     # TRACE

global fetch2code4qpu                                                   # Fetched code

global import2use4qpu                                                   # Imports of target function for Process4Xi

global kb2fetch4qpu                                                     # Knowledgebase for fetching
global kb2kernel4qpu                                                    # Knowledgebase for kernel   

global folder2lib4qpu                                                   # Folder of QPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4qpu

global target2function4qpu                                              # Target function for Process4Xi
      
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2commandqueue4qpu" usage = "
#
# 
#   task4create2qpu = {}                                                                                            
#   task4create2qpu= {}      
#   task4create2qpu['FUNCTION2CALLBACK'] = trace2commandqueue4qpu                                              # CALLBACK FUNCTION CALLED BY QPUIZED OPENCL
# 
#   args2callback = {}                                                                                                          
#   args2callback['CLASS']   = "create2commandqueue4qpu"                                                          # MODULE OF QPUIZED OPENCL MODULE
#   args2callback['METHOD']  = "create2commandqueue4qpu"                                                          # FUNCTION OF QPUIZED OPENCL MODULE
#   args2callback['MESSAGE'] = "{(Step 2Z1/33) failed" + "; create2commandqueue4qpu-failed " + "; time: " + time4xi() + "}"          # ERROR MESSAGE FOR QPUIZED OPENCL TO RETURN    
#   
#   task4create2qpu['ARGS2CALLBACK'] = args2callback                                                              # MAX ONE ARG - THEREFORE GIVE SEVERAL ARGS IN ONE DICTIONARY 
#   
#   response4create2commandqueue = {}
#   print('(Step 1A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO CREATE COMMANDQUEUE FOR QPU ', time4xi())  
#   try:                               
#       response4create2commandqueue = create2commandqueue4qpu (task4create2commandqueue)                         # EXAMINE RESPONSE!                                                      
#       print('(Step 1B/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4CREATE2COMMANDQUEUE : ', response4create2commandqueue)# trace2commandqueue4qpu CALLED BY QPUIZED OPENCL IN EXCEPTIONS - CHECK QPUIZED TRACE!                       
#   except: 
#       print('(Step Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO CREARE COMMANDQUEUE FOR QPU ', time4xi())  
# 
#">

# -------------------------------------------------------------------------------------------------   
def trace2commandqueue4qpu(task4trace2qpu=None):

    '''
    creates qpu2commandqueue4xi
    '''
    
    global qpu2trace4xi 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2commandqueue4qpu" 
    method2print = "trace2commandqueue4qpu"

    message2print = "{(Step 1A/33) started" + "; trace2commandqueue4qpu-started: " + str(trace2commandqueue4qpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2qpu-to-trace2commandqueue4qpu: " + str(task4trace2qpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    qpu2trace4xi = {}                                                                                            # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2qpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY QPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2qpu = {}                                                                                            
            
        task4trace2qpu= {} 
  
        message2print = "{(Step 2A/33) warned" + "; task4trace2qpu-warned-by-trace2commandqueue4qpu to: " + str(task4trace2qpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
        code2nack = code2nack + '2A-'            

    else:
        # -----------------------------------------------------------------------------------------
        # PARAMETER GIVEN BY QPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------          
        message2print = "{(Step 3A/33) try" + "; task4trace2qpu-try-by-trace2commandqueue4qpu: " + str(task4trace2qpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 

        try:
            class2print   = task4trace2qpu['CLASS']                                                              # QPUIZE QPU TRACE!
            method2print  = task4trace2qpu['METHOD']
            message2print = task4trace2qpu['MESSAGE']
            print4xi(class2print, method2print, message2print)                                                      # QPUIZED TRACE FOR OPENCL CALLBACK!
            # =================================
            # 
            # =================================
            
            class2print = "trace2commandqueue4qpu"                                                               # SET TRACE BACK TO THIS FUNCTION!
            method2print = "trace2commandqueue4qpu"                
            message2print = "{(Step 3B/33) performed" + "; qpu-trace-performed-by-trace2commandqueue4qpu: " + str(task4trace2qpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 

            code2ack = code2ack + '3B-' 
        except:
            message2print = "{(Step 3Z1/33) failed" + "; qpu-trace-failed-by-trace2commandqueue4qpu: " + str(task4trace2qpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            code2nack = code2nack + '3Z1-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; trace2commandqueue4qpu-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    # 
    
    return
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2commandqueue4qpu" usage = "
#     
#   commandqueue4xi = {}        
#   try:
#       commandqueue4xi['QPU'] = create2commandqueue4qpu()                                                  # QPU commandqueue      
#       message2print = "{(Step 2B/33) initialized" + "; qpu-commandqueue4xi-created-by-create2commandqueue4xi: " + str(commandqueue4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # commandqueue of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; commandqueue4xi-yielded-by-create2commandqueue4xi: " + str(commandqueue4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2commandqueue4qpu(task4create2qpu=None):

    '''
    creates qpu2commandqueue4xi
    '''
    
    global qpu2commandqueue4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2commandqueue4qpu" 
    method2print = "create2commandqueue4qpu"

    message2print = "{(Step 1A/70) started" + "; create2commandqueue4qpu-started: " + str(create2commandqueue4qpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2commandqueue4qpu at 0x00000000036A3CC8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2qpu-to-create2commandqueue4qpu: " + str(task4create2qpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    qpu2commandqueue4xi = {}                                                                                     # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2qpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO QPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4create2qpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2qpu-created-by-create2commandqueue4qpu: " + str(task4create2qpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4qpu = trace2commandqueue4qpu                                                    # CALLBACK FUNCTION FOR QPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4qpu-created-by-create2commandqueue4qpu: " + str(function2callback4qpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2commandqueue4qpu at 0x00000000036A31C8>
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2commandqueue4qpu"                                                 # MODULE OF QPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2commandqueue4qpu"                                                 # FUNCTION OF QPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2commandqueue4qpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR QPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2commandqueue4qpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 09:01:12 05/18/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}; time: 09:01:12 05/18/11 Pacific Daylight Time}


            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACK - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4create2qpu['DATA2CALLBACK'] = args2callback                                                     # USER DATA PASSED TO QPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2qpu['FUNCTION2CALLBACK'] = function2callback4qpu                                      # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4create2qpu-created-by-create2commandqueue4qpu: " + str(task4create2qpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x00000000036A31C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 09:01:12 05/18/11 Pacific Daylight Time}', 
            #  'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}}; time: 09:01:12 05/18/11 Pacific Daylight Time}

            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2commandqueue4qpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2commandqueue4qpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 09:01:12 05/18/11 Pacific Daylight Time}

                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2commandqueue4qpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4create2qpu['PLATFORM'] = platform2xi                                                            # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT                         
            # ---------------------------------------------------------------------------------------------    
            context2qpu = None
            message2print = "{(Step 3A/70) trying" + "; context2qpu-trying-by-create2commandqueue4qpu: " + str(context2qpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2qpu = get2context4qpu()                                                               # NO PARAMETERS - THE SYSTEM CREATES   
                
                message2print = "{(Step 3B/70) got" + "; context2qpu-got-by-create2commandqueue4qpu: " + str(context2qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 09:38:20 05/19/11 Pacific Daylight Time}', 
                #            'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x0000000003220D48>, 
                #       'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 
                #         'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
                #      'NACK2RETURN': ' ', 
                #     'SIZE2PRIVATE': 0, 
                #       'PROPERTIES': None
                #}; time: 09:38:20 05/19/11 Pacific Daylight Time}
 
                
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2qpu-failed-by-create2commandqueue4qpu: " + str(context2qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
            task4create2qpu ['CONTEXT'] = context2qpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE                           
            # ---------------------------------------------------------------------------------------------    
            device2qpu = None
            message2print = "{(Step 4A/70) trying" + "; device2qpu-trying-by-create2commandqueue4qpu: " + str(device2qpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2qpu = get2qpu4xi()                                                                     # NO PARAMETERS - THE SYSTEM CREATES    
                
                message2print = "{(Step 4B/70) got" + "; device2qpu-got-by-create2commandqueue4qpu: " + str(device2qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
                #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4,
                #  'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
                #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
                #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
                #  'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK',
                #  'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
                #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
                #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64,
                #  'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK',
                #  'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK',
                #  'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4,
                #  'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024,
                #  'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024,
                #  'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK',
                #  'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1
                # , 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_QPU',
                #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}; time: 02:44:39 05/21/11 Pacific Daylight Time}
 
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2qpu-failed-by-create2commandqueue4qpu: " + str(device2qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4create2qpu ['DEVICE'] = device2qpu
            
            # ---------------------------------------------------------------------------------------------
            # (5) Private INFO - EXTRA                            
            # ---------------------------------------------------------------------------------------------             
            task4create2qpu['INFO2PRIVATE'] = None
            
            # ---------------------------------------------------------------------------------------------
            # (6) PROPERTIES                           
            # ---------------------------------------------------------------------------------------------         
            task4create2qpu ['PROPERTIES'] = None                              

            # ---------------------------------------------------------------------------------------------
            # (7) ERROR CODE                           
            # ---------------------------------------------------------------------------------------------         
            task4create2qpu ['CODE2ERROR'] = 0             
                        
            # ---------------------------------------------------------------------------------------------
            # (8) REFERENCE COUNT                       
            # ---------------------------------------------------------------------------------------------              
            task4create2qpu ['COUNT2REFERENCE'] = 0                                                              # USED TO RETAIN(ATTACH) AND RELEASE COMMANDQUEUE 
              
            message2print = "{(Step 8A/70) created" + "; task4create2qpu-created-by-create2commandqueue4qpu: " + str(task4create2qpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 03:30:55 05/21/11 Pacific Daylight Time}',
            #  'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x0000000003795B48>,
            #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 03:30:55 05/21/11 Pacific Daylight Time}',
            #  'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x000000000375E448>,
            #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
            #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
            #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568',
            #  'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472,
            #  'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
            #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
            #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
            #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
            #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
            #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
            #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK',
            #  'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4,
            #  'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024,
            #  'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024,
            #  'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK',
            #  'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ',
            #  'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
            #  'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None}; time: 03:30:55 05/21/11 Pacific Daylight Time}
 
            code2ack  = code2ack + '8A-'

            # ---------------------------------------------------------------------------------------------
            # (9) QUEUE                          
            # ---------------------------------------------------------------------------------------------         
            queue2qpu = None
            message2print = "{(Step 9A/70) trying" + "; queue2qpu-trying-by-create2commandqueue4qpu: " + str(queue2qpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2qpu = Queue4Xi()                                                                           # NO PARAMETERS - THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 9B/70) got" + "; queue2qpu-got-by-create2commandqueue4qpu: " + str(queue2qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # =================================
                # multiprocessing4xi trace
                # =================================
                # { Queue4Xi : __init__ ; (Step 1/11a) started; init-of-Queue4Xi-started: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 2/11a) got; csys2xi-got-by-init-of-Queue4Xi: <constant_system4xi.ConstantSystem4Xi object at 0x00000000041FDCF8>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 3/11a) set; maxsize-set-by-init-of-Queue4Xi to: 2147483647; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 2/8a) got; pipe2xi-got-by-Pipe4Xi: AF_PIPE; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { init_max_response_message_length4xi : init_max_response_message_length4xi ; initialized; max-response-message-length-initialized-by-init-max-response-message-length4xi to: 8192; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 3/8b) set; buffersize2xi-set-by-Pipe4Xi to: 8192; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 5/8a) set; surfboard-one2xi-set-by-Pipe4Xi to: 240; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 5/8c1) passing; wave2pipe-passing-to-win32-CreateFile-by-Pipe4Xi: \\.\pipe\pyc-5092-0-anfv1c; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 5/8c8) set; surfboard-two2xi-set-by-Pipe4Xi to: 288; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 5/8e1) passing; surfboard-two2xi-passing-to-win32-SetNamedPipeHandleState-by-Pipe4Xi: 288; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 5/8e2) passing; win32-PIPE-READMODE-MESSAGE-passing-to-win32-SetNamedPipeHandleState-by-Pipe4Xi: 2; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 7/8b1) performed; PipeConnection-performed-by-Pipe4Xi: <class '_multiprocessing.PipeConnection'>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Pipe4Xi : Pipe4Xi ; (Step 7/8b2) got; connection-one2xi-got-by-Pipe4Xi: <read-only PipeConnection, handle 240>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 4/11b) set; reader-of-queue2xi-set-by-init-of-Queue4Xi: <read-only PipeConnection, handle 240>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 4/11c) set; writer-of-queue2xi-set-by-init-of-Queue4Xi: <write-only PipeConnection, handle 288>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Lock4Xi : __init__ ; inheriting; SemLock4Xi-inheriting-by-lock2xi-of-Lock4Xi: <class 'semlock4xi.SemLock4Xi'>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 5/11) set; rlock-of-queue2xi-set-by-init-of-Queue4Xi to: <Lock(owner=None)>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 6/11) set; opid-of-queue2xi-set-by-init-of-Queue4Xi to: 5092; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 7/11a) set; wlock-of-queue2xi-set-by-init-of-Queue4Xi to: None; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 8/11a) passing; maxsize-passing-to-BoundedSemaphore4Xi-by-init-of-Queue4Xi: 2147483647; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; started; after-fork-of-Queue4Xi-started: ; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 1/11) set; notempty-of-queue2xi-set-by-after-fork-of-Queue4Xi to: <Condition(<_thread.lock object at 0x00000000041C9D30>, 0)>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 3/11) set; thread-of-queue2xi-set-by-after-fork-of-Queue4Xi to: None; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 4/11) set; jointhread-of-queue2xi-set-by-after-fork-of-Queue4Xi to: None; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; Step 5/11) set; joincancelled-of-queue2xi-set-by-after-fork-of-Queue4Xi to: False; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 6/11) set; closed-of-queue2xi-set-by-after-fork-of-Queue4Xi to: False; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 7/11) set; close-of-queue2xi-set-by-after-fork-of-Queue4Xi to: None; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 8/11) set; send-of-queue2xi-set-by-after-fork-of-Queue4Xi to: <built-in method send of _multiprocessing.PipeConnection object at 0x0000000004156D70>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 9/11) set; recv-of-queue2xi-set-by-after-fork-of-Queue4Xi to: <built-in method recv of _multiprocessing.PipeConnection object at 0x0000000004156940>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 10/11) set; poll-of-queue2xi-set-by-after-fork-of-Queue4Xi to: <built-in method poll of _multiprocessing.PipeConnection object at 0x0000000004156940>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : _after_fork ; (Step 11/11) returning; after-fork-of-Queue4Xi-returning: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 9/11) performed; after-fork-of-queue2xi-performed-by-init-of-Queue4Xi: <bound method Queue4Xi._after_fork of <queue4xi.Queue4Xi object at 0x00000000041FDA58>>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 11/11a) activated; queue2xi-of-Queue4Xi-activated: ; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 11/11b) inherited; object-inherited-by-queue2xi-of-Queue4Xi: <class 'object'>; time: 21:28:02 06/13/11 Pacific Daylight Time}
                # { Queue4Xi : __init__ ; (Step 11/11c) returning; init-of-Queue4Xi-returning: 21:28:02 06/13/11 Pacific Daylight Time}
                # =================================                
                # end of multiprocessing4xi trace
                # =================================                
                
                # ====================================                  
                # queue object from multiprocessing4xi 
                # ====================================
                # <queue4xi.Queue4Xi object at 0x00000000041F8DD8>
                
                code2ack  = code2ack + '9B-'  
            except:
                message2print = "{(Step 9Z/70) failed" + "; queue2qpu-failed-by-create2commandqueue4qpu: " + str(queue2qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
                
            task4create2qpu ['QUEUE'] = queue2qpu

            
            # ---------------------------------------------------------------------------------------------
            # (10) PIPE                          
            # ---------------------------------------------------------------------------------------------         
            pipe2qpu = None
            message2print = "{(Step 10A/70) trying" + "; pipe2qpu-trying-by-create2commandqueue4qpu: " + str(pipe2qpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2qpu = Pipe4Xi()                                                                             # NO PARAMETERS - THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 10B/70) got" + "; pipe2qpu-got-by-create2commandqueue4qpu: " + str(pipe2qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # =================================
                # multiprocessing4xi trace
                # =================================
                # { Pipe4Xi : Pipe4Xi ; (Step 8/8b) returning; connection-two2xi-returning-by-Pipe4Xi: <read-write PipeConnection, handle 1012>; time: 04:10:50 08/08/11 Pacific Daylight Time}
                # =================================                
                # end of multiprocessing4xi trace
                # =================================                
                
                # ====================================                  
                # pipe object from multiprocessing4xi 
                # ====================================
                # (<read-write PipeConnection, handle 1008>, <read-write PipeConnection, handle 1012>); time: 04:10:50 08/08/11 Pacific Daylight Time}

                
                code2ack  = code2ack + '10B-'  
            except:
                message2print = "{(Step 10Z/70) failed" + "; pipe2qpu-failed-by-create2commandqueue4qpu: " + str(pipe2qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
                
            task4create2qpu ['PIPE'] = pipe2qpu 
            
                       
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2qpu-yielded-by-create2commandqueue4qpu: " + str(task4create2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        code2nack  = code2nack + '1Z1-' 

    qpu2commandqueue4xi = {}                                                                                     # INITIALIZE QPU COMMANDQUEUE                                                                                      

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2qpu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2commandqueue4qpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'DATA2CALLBACK' in keys2task:
                                                                                                                    # CREATE! 
        message2print = "{(Step 9A/70) try" + "; data2callback-try-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 9/70) - DATA2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['DATA2CALLBACK'] = task4create2qpu['DATA2CALLBACK']
            
            message2print = "{(Step 9B/70) initialized" + "; data2callback-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '9B-'
        except: 
            message2print = "{(Step 9Z1/70) yielded" + "; data2callback-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '9Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:        
        message2print = "{(Step 10A/70) try" + "; function2callback-try-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 10/70) - FUNCTION2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['FUNCTION2CALLBACK'] = task4create2qpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 10B/70) initialized" + "; function2callback-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '10B-'
        except: 
            message2print = "{(Step 10Z1/70) yielded" + "; function2callback-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '10Z1-' 

    if 'INFO2PRIVATE' in keys2task:           
        message2print = "{(Step 11A/70) try" + "; info2private-try-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 11/70) - INFO2PRIVATE - EXTRA
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['INFO2PRIVATE'] = task4create2qpu['INFO2PRIVATE']
            
            message2print = "{(Step 11B/70) initialized" + "; info2private-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '11B-'
        except: 
            message2print = "{(Step 11Z1/70) yielded" + "; info2private-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '11Z1-'             

    if 'CONTEXT' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 12/70) - CONTEXT
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['CONTEXT'] = task4create2qpu['CONTEXT']
            
            message2print = "{(Step 12B/70) initialized" + "; context-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '12B-'
        except: 
            message2print = "{(Step 12Z1/70) yielded" + "; context-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '12Z1-' 

    if 'DEVICE' in keys2task:        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 13/70) - DEVICE
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['DEVICE'] = task4create2qpu['DEVICE']
            
            message2print = "{(Step 13B/70) initialized" + "; device-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '13B-'
        except: 
            message2print = "{(Step 13Z1/70) yielded" + "; device-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '13Z1-'         

    if 'PROPERTIES' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 14/70) - PROPERTIES (EXECUTION and PROFILING)
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['PROPERTIES'] = task4create2qpu['PROPERTIES']
            
            message2print = "{(Step 14B/70) initialized" + "; properties-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '14B-'
        except: 
            message2print = "{(Step 14Z1/70) yielded" + "; properties-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '14Z1-'     

    if 'CODE2ERROR' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 15/70) - ERROR CODE
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['CODE2ERROR'] = task4create2qpu['CODE2ERROR']
            
            message2print = "{(Step 15B/70) initialized" + "; code2error-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '15B-'
        except: 
            message2print = "{(Step 15Z1/70) yielded" + "; code2error-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '15Z1-'                

    if 'COUNT2REFERENCE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 16/70) - REFERENCE COUNT
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['COUNT2REFERENCE'] = task4create2qpu['COUNT2REFERENCE']
            
            message2print = "{(Step 16B/70) initialized" + "; reference-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '16B-'
        except: 
            message2print = "{(Step 16Z1/70) yielded" + "; reference-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '16Z1-'                     

    if 'QUEUE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 17/70) - QUEUE
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['QUEUE'] = task4create2qpu['QUEUE']
            
            message2print = "{(Step 17B/70) initialized" + "; queue-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x00000000041FDA58> 
            code2ack  = code2ack + '17B-'
        except: 
            message2print = "{(Step 17Z1/70) yielded" + "; queue-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '17Z1-'                         

    if 'PIPE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 18/70) - PIPE
            # -----------------------------------------------------------------------------------------               
            qpu2commandqueue4xi['PIPE'] = task4create2qpu['PIPE']
            
            message2print = "{(Step 18B/70) initialized" + "; pipe-created-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 344>, <read-write PipeConnection, handle 348>); time: 04:10:49 08/08/11 Pacific Daylight Time}
            
            code2ack  = code2ack + '18B-'
        except: 
            message2print = "{(Step 18Z1/70) yielded" + "; pipe-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '18Z1-'   

                                                 
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    qpu2commandqueue4xi ['ACK2RETURN']  = code2ack
    qpu2commandqueue4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; qpu2commandqueue4xi-returning-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0, 
    #  'COUNT2REFERENCE': 0, 
    #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 03:30:55 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x0000000003795B48>,
    #  'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-11B-12B-13B-14B-15B-16B-', 'INFO2PRIVATE': None, 'NACK2RETURN': ' ',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 03:30:55 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x000000000375E448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 
    #  'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2,
    #  'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
    #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write',
    #  'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
    #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
    #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
    #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
    #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
    #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
    #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK',
    #  'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ',
    #  'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
    #  'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None}; time: 03:30:55 05/21/11 Pacific Daylight Time}

    
    return qpu2commandqueue4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2commandqueue4qpu" usage = "
#
#   # Example (from commandqueue4xi.py - task4set2commandqueue got as parameter - see commandqueue4xi5test.py)
#
#   if commandqueue4xi is None:
#       commandqueue4xi = create2commandqueue4xi()                                                                # CREATE COMMANDQUEUE4XI
#   try:
#       # -----------------------------------------------------------------------------
#       # (Step 4A/33)
#       # ----------------------------------------------------------------------------- 
#       message2print = "{(Step 4A/33) passing" + "; task-passing-to-set2commandqueue4qpu: " + str(task4set2commandqueue['QPU'])  + "; time: " + time4xi() + "}"  
#       print4xi(class2print, method2print, message2print)                                                         
#        
#       commandqueue4xi ['QPU'] = set2commandqueue4qpu(task4set2commandqueue['QPU'])                         # 
#          
#       message2print = "{(Step 4B/33) set" + "; qpu-commandqueue-set-by-set2commandqueue4qpu to: " + str(commandqueue4xi ['QPU'])  + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                          
#       code2ack  = code2ack + '4B-'
#   except:
#       message2print = "{(Step 4Z1/33) yielded" + "; qpu-yielded-by-set2commandqueue4xi: " + 'QPU' + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print) 
#       code2nack  = code2nack + '4Z1-'
#">

# -------------------------------------------------------------------------------------------------   
def set2commandqueue4qpu(task4set2qpu=None):

    '''
    sets qpu2commandqueue4xi
    '''
    global qpu2commandqueue4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2commandqueue4qpu"
    method2print = "set2commandqueue4qpu"

    message2print = "{(Step 1A/33) started" + "; set2commandqueue4qpu-started: " + str(set2commandqueue4qpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4set2qpu-to-set2commandqueue4qpu: " + str(task4set2qpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if qpu2commandqueue4xi is None:
            qpu2commandqueue4xi = create2commandqueue4qpu()                                                   # INITIALIZE COMMANDQUEUE FOR QPU                      
    except:
        try:
            qpu2commandqueue4xi = create2commandqueue4qpu()
        except:
            qpu2commandqueue4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 9A/70) try" + "; data2callback-try-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 2/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['DATA2CALLBACK'] = task4set2qpu['DATA2CALLBACK']
        
        message2print = "{(Step 9B/70) set" + "; data2callback-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '9B-'
    except: 
        message2print = "{(Step 9Z1/70) yielded" + "; data2callback-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '9Z1-'
    
    message2print = "{(Step 10A/70) try" + "; function2callback-try-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 10/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['FUNCTION2CALLBACK'] = task4set2qpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 10B/70) set" + "; function2callback-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '10B-'
    except: 
        message2print = "{(Step 10Z1/70) yielded" + "; function2callback-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '10Z1-' 
           
    message2print = "{(Step 11A/70) try" + "; info2private-try-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11/70) - INFO2PRIVATE - EXTRA
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['INFO2PRIVATE'] = task4set2qpu['INFO2PRIVATE']
        
        message2print = "{(Step 11B/70) set" + "; info2private-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '11B-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; info2private-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-'             
    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12/70) - CONTEXT
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['CONTEXT'] = task4set2qpu['CONTEXT']
        
        message2print = "{(Step 12B/70) set" + "; context-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '12B-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; context-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13/70) - DEVICE
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['DEVICE'] = task4set2qpu['DEVICE']
        
        message2print = "{(Step 13B/70) set" + "; device-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '13B-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; device-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-'         

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14/70) - PROPERTIES (EXECUTION and PROFILING)
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['PROPERTIES'] = task4set2qpu['PROPERTIES']
        
        message2print = "{(Step 14B/70) set" + "; properties-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '14B-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; properties-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'     

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 15/70) - ERROR CODE
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['CODE2ERROR'] = task4set2qpu['CODE2ERROR']
        
        message2print = "{(Step 15B/70) set" + "; code2error-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '15B-'
    except: 
        message2print = "{(Step 15Z1/70) yielded" + "; code2error-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '15Z1-'                
                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 16/70) - REFERENCE COUNT
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['COUNT2REFERENCE'] = task4set2qpu['COUNT2REFERENCE']
        
        message2print = "{(Step 16B/70) initialized" + "; reference-initialized-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '16B-'
    except: 
        message2print = "{(Step 16Z1/70) yielded" + "; reference-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '16Z1-'                     
            
                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 17/70) - QUEUE
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['QUEUE'] = task4set2qpu['QUEUE']
        
        message2print = "{(Step 17B/70) set" + "; queue-set-by-set2commandqueue4qpu to: " + str(qpu2commandqueue4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <queue4xi.Queue4Xi object at 0x0000000005CF40F0> 
        code2ack  = code2ack + '17B-'
    except: 
        message2print = "{(Step 17Z1/70) yielded" + "; queue-qpu2commandqueue4xi-yielded-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '17Z1-'                                                                                                  
                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 18/70) - PIPE 
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['PIPE'] = task4set2qpu['PIPE']
        
        message2print = "{(Step 18B/70) set" + "; pipe-set-by-create2commandqueue4qpu to: " + str(qpu2commandqueue4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '18B-'
    except: 
        message2print = "{(Step 18Z1/70) yielded" + "; pipe-qpu2commandqueue4xi-yielded-by-create2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '18Z1-'   
                    
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    qpu2commandqueue4xi ['ACK2RETURN']  = code2ack
    qpu2commandqueue4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; qpu2commandqueue4xi-returning-by-set2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 04:38:48 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x00000000035B5B48>,
    #  'ACK2RETURN': ' 12B-13B-14B-15B-', 'INFO2PRIVATE': None, 'NACK2RETURN': ' 9Z1-10Z1-11Z1-16Z1-',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 04:38:48 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x000000000357E448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 
    #  'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
    #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4,
    #  'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
    #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
    #  'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
    #  'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
    #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
    #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0,
    #  'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
    #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK',
    #  'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
    #  'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
    #             'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'PROPERTIES': {'EXECUTION': 'IN2ORDER', 'PROFILING': 'ENABLE'}}; time: 04:38:48 05/21/11 Pacific Daylight Time}


    return qpu2commandqueue4xi

            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2commandqueue4qpu" usage = "
#
#   # Example (see commandqueue4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECRENTING COUNT WITH 1             
#   task4release2commandqueue = {}
#   task4release2commandqueue ['QPU'] = {} 
#    
#   task4release2commandqueue ['QPU'] ['COUNT2REFERENCE'] = 1                                                    # REFERENCE COUNT
#   response4release2commandqueue = {}
#   
#   print('(Step 5A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO RELEASE COMMANDQUEUE OF QPU DEVICE ', time4xi())  
#   try:                               
#       response4release2commandqueue = release2commandqueue4xi(task4release2commandqueue)                          # COUNT2REFERENCE                                                      
#       print('(Step 5BD/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4RELEASE2COMMANDQUEUE : ', response4release2commandqueue)                          
#       
#   except:
#       print('(Step 5Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO RELEASE COMMANDQUEUE OF QPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def release2commandqueue4qpu(task4release2qpu=None):

    '''
    releases qpu2commandqueue4xi
    '''
    global qpu2commandqueue4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2commandqueue4qpu"
    method2print = "release2commandqueue4qpu" 

    message2print = "{(Step 1A/33) started" + "; release2commandqueue4qpu-started: " + str(release2commandqueue4qpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4release2qpu-to-release2commandqueue4qpu: " + str(task4release2qpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if qpu2commandqueue4xi is None:
            qpu2commandqueue4xi = create2commandqueue4qpu()                                                   # INITIALIZE COMMANDQUEUE                 
    except:
        try:
            qpu2commandqueue4xi = create2commandqueue4qpu()
        except:
            qpu2commandqueue4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; qpu2commandqueue4xi-yielded-by-release2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2qpu is None:
        task4release2qpu = {}
        task4release2qpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['COUNT2REFERENCE'] = qpu2commandqueue4xi['COUNT2REFERENCE'] - task4release2qpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2commandqueue4qpu: " + str(qpu2commandqueue4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if qpu2commandqueue4xi['COUNT2REFERENCE'] < 0:
            qpu2commandqueue4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2commandqueue4qpu: " + " ** " + str(qpu2commandqueue4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            qpu2commandqueue4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2commandqueue4qpu: " + " ** " + str(qpu2commandqueue4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; qpu2commandqueue4xi-yielded-by-release2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    qpu2commandqueue4xi ['ACK2RETURN']  = code2ack
    qpu2commandqueue4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; qpu2commandqueue4xi-returning-by-release2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 8Z1-',
    #  'CONTEXT': {'COUNT2REFERENCE': 0,
    #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 04:38:48 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x000000000357E448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568',
    #  'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472,
    #  'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
    #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
    #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
    #  'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0,
    #  'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK',
    #  'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE',
    #  'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0,
    #  'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024,
    #  'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16,
    #  'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
    #  'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128,
    #  'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'PROPERTIES': None}; time: 04:38:48 05/21/11 Pacific Daylight Time}
 
    
    return qpu2commandqueue4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2commandqueue4qpu" usage = "
#
#   # Example (see commandqueue4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAIND BY INCREMENTING COUNT WITH 1             
#   task4retain2commandqueue = {}
#   task4retain2commandqueue ['QPU'] = {} 
#    
#   task4retain2commandqueue ['QPU'] ['COUNT2REFERENCE'] = 1                  # ADD REFERENCE COUNT BY 1
#   response4retain2commandqueue = {}
#   
#   print('(Step 5A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO RETAIN COMMANDQUEUE OF QPU DEVICE ', time4xi())  
#   try:                               
#       response4retain2commandqueue = retain2commandqueue4xi(task4retain2commandqueue)                                                                                          
#       print('(Step 5BD/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4RETAIN2COMMANDQUEUE : ', response4retain2commandqueue)                          
#       
#   except:
#       print('(Step 5Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO RETAIN COMMANDQUEUE OF QPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def retain2commandqueue4qpu(task4retain2qpu=None):

    '''
    retains qpu2commandqueue4xi
    '''
    global qpu2commandqueue4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2commandqueue4qpu"
    method2print = "retain2commandqueue4qpu"

    message2print = "{(Step 1A/33) started" + "; retain2commandqueue4qpu-started: " + str(retain2commandqueue4qpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2qpu-to-retain2commandqueue4qpu: " + str(task4retain2qpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if qpu2commandqueue4xi is None:
            qpu2commandqueue4xi = create2commandqueue4qpu()                                                   # INITIALIZE COMMANDQUEUE                 
    except:
        try:
            qpu2commandqueue4xi = create2commandqueue4qpu()
        except:
            qpu2commandqueue4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; qpu2commandqueue4xi-yielded-by-retain2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; retain-try-by-retain2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
           
    try:
        # -----------------------------------------------------------------------------------------
        # RETAIN
        # -----------------------------------------------------------------------------------------               
        qpu2commandqueue4xi['COUNT2REFERENCE'] = qpu2commandqueue4xi['COUNT2REFERENCE'] + task4retain2qpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1C/70) calculated" + "; count2reference-calculated-by-retain2commandqueue4qpu: " + str(qpu2commandqueue4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #
         
        if qpu2commandqueue4xi['COUNT2REFERENCE'] <= 0:
            qpu2commandqueue4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1D/70) warning" + "; count2reference-warning-by-retain2commandqueue4qpu: " + " ** " + str(qpu2commandqueue4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1D-'
        else:
            code2ack  = code2ack + '1D-'
    except:
        try:
            qpu2commandqueue4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1Z1/70) warning" + "; count2reference-warning-by-retain2commandqueue4qpu: " + " ** " + str(qpu2commandqueue4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '1Z1-'
            
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; qpu2commandqueue4xi-yielded-by-retain2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    qpu2commandqueue4xi ['ACK2RETURN']  = code2ack
    qpu2commandqueue4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; qpu2commandqueue4xi-returning-by-retain2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'ACK2RETURN': ' 1D-', 'NACK2RETURN': ' ',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 04:38:48 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x000000000357E448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0,
    #  'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
    #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472,
    #  'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
    #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
    #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
    #  'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
    #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE',
    #  'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2,
    #  'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024,
    #  'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD',
    #  'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824,
    #  'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
    #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1,
    #  'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
    #  'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'PROPERTIES': None}; time: 04:38:48 05/21/11 Pacific Daylight Time}
 
    
    return qpu2commandqueue4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2commandqueueinfo4qpu" usage = "
#
#   try:                               
#       response4get2qpu = get2commandqueueinfo4qpu()                                        
#                                                                                                                   
#   except:
#       ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2commandqueueinfo4qpu():

    '''
    gets qpu2commandqueue4xi
    '''
    
    global qpu2commandqueue4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2commandqueueinfo4qpu"
    method2print = "get2commandqueueinfo4qpu"

    message2print = "{(Step 1A/33) started" + "; get2commandqueueinfo4qpu-started: " + str(get2commandqueueinfo4qpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                                                               
    try: 
        if qpu2commandqueue4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            qpu2xi = create2commandqueue4qpu()
            message2print = "{(Step 1B/33) initialized" + "; qpu2xi-initialized-by-get2commandqueueinfo4qpu to: " + str(qpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                
        else:
            # -------------------------------------------------------------------------------------
            # RETURN THE EXISTING COMMANDQUEUE FOR QPU          
            # -------------------------------------------------------------------------------------     
            qpu2xi = qpu2commandqueue4xi
            message2print = "{(Step 1C/33) got" + "; qpu2xi-got-by-get2commandqueueinfo4qpu: " + str(qpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            qpu2xi = create2commandqueue4qpu()
            message2print = "{(Step 1D/33) initialized" + "; qpu2xi-initialized-by-get2commandqueueinfo4qpu to: " + str(qpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                        
        except:
            qpu2xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; qpu2xi-yielded-by-get2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; qpu2xi-returning-by-get2commandqueueinfo4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
    
    return qpu2xi
            
#</function4xi> 
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "flush2commandqueue4qpu" usage = "
#   print('(Step 2A/33) OF QPU2COMMANDQUEUE4XI5TEST - TRYING TO CREATE COMMANDQUEUE4QPU ', time4xi())   
#   try:
#       cq2qpu = create2commandqueue4qpu()                                                                           
#       print('(Step 2B/33) OF QPU2COMMANDQUEUE4XI5TEST - CREATED COMMANDQUEUE4QPU: ', cq2qpu)                                  
#   except:
#       print('(Step 2Z/33) OF QPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE COMMANDQUEUE4QPU', time4xi()) 
#       ...
#   print('(Step 2B1/33) OF QPU2COMMANDQUEUE4XI5TEST - TRYING TO FLUSH COMMANDQUEUE4QPU ', time4xi())      
#     
#   task4flush2commandqueue = cq2qpu
#   try:
#       flush2qpu = flush2commandqueue4qpu(task4flush2commandqueue)                                                     
#       print('(Step 2B2/33) OF QPU2COMMANDQUEUE4XI5TEST - FLUSHED COMMANDQUEUE4QPU: ', flush2qpu)                                  
#       # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 
#       # 'SIZE2QUEUE': 2147483646, 
#       # 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 05:58:39 08/11/11 Pacific Daylight Time}',
#       # 'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}, 
#       # 'EMPTY2QUEUE': True, 
#       # 'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x000000000399F0C8>, 
#       # 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-',
#       # 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000395C470>, 
#       # 'FULL2QUEUE': False, 
#       # 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 
#       # 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 05:58:39 08/11/11 Pacific Daylight Time}', 'CLASS': 'create2context4qpu',
#       # 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x0000000003788948>,
#       # 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
#       # 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
#       # 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318,
#       # 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2,
#       # 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
#       # 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
#       # 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
#       # 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
#       # 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
#       # 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
#       # 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0,
#       # 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK',
#       # 'MAX2SIZE4KERNELARGUMENT': 4096,
#       # 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
#       # 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE',
#       # 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2,
#       # 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024,
#       # 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
#       # 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8,
#       # 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
#       # 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128,
#       # 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
#       # 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 348>, <read-write PipeConnection, handle 352>)}
#        
#   except:
#       print('(Step 2BZ/33) OF QPU2COMMANDQUEUE4XI5TEST *** FAILED TO FLUSH COMMANDQUEUE4QPU', time4xi())    
#                          
#">

# -------------------------------------------------------------------------------------------------   
def flush2commandqueue4qpu(task4flush2commandqueue=None):

    '''
    flushes qpu2commandqueue4qpu
    '''
    
    global qpu2commandqueue4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "flush2commandqueue4qpu"
    method2print = "flush2commandqueue4qpu"

    message2print = "{(Step 1A1/33) started" + "; flush2commandqueue4qpu-started: " + str(flush2commandqueue4qpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
    message2print = "{(Step 1A2/33) passed" + "; task4flush2commandqueue-passed-by-flush2commandqueue4qpu to: " + str(task4flush2commandqueue)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                                                
    try: 
        if qpu2commandqueue4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE - KEEP SYSTEM RUNNING           
            # -------------------------------------------------------------------------------------           
            qpu2commandqueue4xi = create2commandqueue4qpu()
            
            message2print = "{(Step 1B/33) created" + "; qpu2commandqueue4xi-created-by-flush2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
                                                
            # -------------------------------------------------------------------------------------
            # FLUSH           
            # -------------------------------------------------------------------------------------             
            queue2commandqueue4qpu = None
            try:
                queue2commandqueue4qpu = qpu2commandqueue4xi['QUEUE']
                message2print = "{(Step 1C/33) got" + "; queue2commandqueue4qpu-got-by-flush2commandqueue4qpu: " + str(queue2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:     
                message2print = "{(Step 1Z1/70) yielded" + "; qpu2xi-yielded-by-flush2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            size2commandqueue4qpu = 0
            try:                    
                size2commandqueue4qpu = queue2commandqueue4qpu.qsize()
                message2print = "{(Step 1D/33) got" + "; size2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(size2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
                               
                
            except:     
                message2print = "{(Step 1Z2/70) yielded" + "; qpu2xi-yielded-by-flush2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
             
            empty2commandqueue4qpu = True       
            try:                    
                empty2commandqueue4qpu= queue2commandqueue4qpu.empty()
                message2print = "{(Step 1E/33) got" + "; empty2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(empty2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
            except:     
                message2print = "{(Step 1Z3/70) yielded" + "; empty2commandqueue4qpu-yielded-by-flush2commandqueue4qpu: " + str(empty2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
             
            full2commandqueue4qpu = False       
            try:                                
                full2commandqueue4qpu = queue2commandqueue4qpu.full()
                message2print = "{(Step 1F/33) got" + "; full2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(full2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #                
            except:     
                message2print = "{(Step 1Z4/70) yielded" + "; full2commandqueue4qpu-yielded-by-flush2commandqueue4qpu: " + str(full2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)   
                            
            message2print = "{(Step 1G/33) flushed" + "; qpu2commandqueue4xi-flushed-by-flush2commandqueue4qpu to: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
                            
        else:
            # -------------------------------------------------------------------------------------
            # USE THE EXISTING COMMANDQUEUE FOR QPU          
            # -------------------------------------------------------------------------------------     
            
            message2print = "{(Step 1H/33) used" + "; qpu2commandqueue4xi-used-by-flush2commandqueue4qpu to: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            # -------------------------------------------------------------------------------------
            # FLUSH           
            # -------------------------------------------------------------------------------------             
            queue2commandqueue4qpu = None
            try:
                queue2commandqueue4qpu = qpu2commandqueue4xi['QUEUE']
                message2print = "{(Step 1I/33) got" + "; queue2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(queue2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            except:     
                message2print = "{(Step 1Z5/70) yielded" + "; qpu2xi-yielded-by-flush2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                
            if task4flush2commandqueue is None:
                pass
            else:
                # -------------------------------------------------------------------------------------
                # COMMAND QUEUE GIVEN AS PARAMETER          
                # -------------------------------------------------------------------------------------               
                message2print = "{(Step 1J1/33) passed" + "; task4flush2commandqueue-passed-by-flush2commandqueue4qpu to: " + str(task4flush2commandqueue)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                queue2task = {}    
                try:
                    queue2task = task4flush2commandqueue ['QUEUE']
                    message2print = "{(Step 1J2/33) set" + "; queue2task-set-by-flush2commandqueue4qpu to: " + str(queue2task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                except:     
                    message2print = "{(Step 1Z61/70) yielded" + "; queue2task-yielded-by-flush2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                
                try:                        
                    if queue2task == queue2commandqueue4qpu:
                        # -------------------------------------------------------------------------------------
                        # ACCEPTED - GIVEN COMMAND QUEUE IS THE SAME          
                        # -------------------------------------------------------------------------------------                     
                        message2print = "{(Step 1K/33) accepted" + "; queue2task-accepted-by-flush2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                    else:
                        try:
                            message2print = "{(Step 1L/33) warned" + "; queue2task-warned-by-flush2commandqueue4qpu: " + " ** " + str(queue2task)  + " ** " + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # 
                        
                            message2print = "{(Step 1M/33) warned" + "; queue2commandqueue4qpu-warned-by-flush2commandqueue4qpu: " + " ** " + str(queue2commandqueue4qpu)  + " ** " + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)    
                            # 
                        except:
                            pass
                                                     
                except:     
                    message2print = "{(Step 1Z62/70) yielded" + "; queue2task-yielded-by-flush2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                   
            
            size2queue4qpu = 0        
            try:                    
                size2queue4qpu = queue2commandqueue4qpu.qsize()
                message2print = "{(Step 1N1/33) got" + "; size2queue4qpu-got-by-flush2commandqueue4qpu to: " + str(size2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                
                qpu2commandqueue4xi ['SIZE2QUEUE'] = size2queue4qpu
                message2print = "{(Step 1N2/33) set" + "; size2queue4commandqueue-got-by-flush2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['SIZE2QUEUE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                  
                # 
            except:     
                message2print = "{(Step 1Z7/70) yielded" + "; size2queue4qpu-yielded-by-flush2commandqueue4qpu: " + str(size2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            empty2queue4qpu = False
            try:                    
                empty2queue4qpu = queue2commandqueue4qpu.empty()
                message2print = "{(Step 1O1/33) got" + "; empty2queue4qpu-got-by-flush2commandqueue4qpu to: " + str(empty2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                
                qpu2commandqueue4xi ['EMPTY2QUEUE'] = empty2queue4qpu
                message2print = "{(Step 1O2/33) set" + "; empty2queue4commandqueue-got-by-flush2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['EMPTY2QUEUE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                    
            except:     
                message2print = "{(Step 1Z8/70) yielded" + "; empty2queue4qpu-yielded-by-flush2commandqueue4qpu: " + str(empty2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            full2queue4qpu = False
            try:                                
                full2queue4qpu = queue2commandqueue4qpu.full()
                message2print = "{(Step 1P1/33) got" + "; full2queue4qpu-got-by-flush2commandqueue4qpu to: " + str(full2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                 
                qpu2commandqueue4xi ['FULL2QUEUE'] = full2queue4qpu
                message2print = "{(Step 1P2/33) set" + "; full2queue4commandqueue-got-by-flush2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['FULL2QUEUE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                               
            except:     
                message2print = "{(Step 1Z9/70) yielded" + "; full2queue4qpu-yielded-by-flush2commandqueue4qpu: " + str(full2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                                                        
            message2print = "{(Step 1Q/33) flushed" + "; qpu2commandqueue4xi-flushed-by-flush2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            qpu2commandqueue4qpu = create2commandqueue4qpu()
            message2print = "{(Step 1R/33) got" + "; qpu2commandqueue4xi-got-by-flush2commandqueue4qpu to: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
            
            # -------------------------------------------------------------------------------------
            # FLUSH           
            # -------------------------------------------------------------------------------------             
            queue2commandqueue4qpu = None
            try:
                queue2commandqueue4qpu = qpu2commandqueue4xi['QUEUE']
                message2print = "{(Step 1S/33) got" + "; queue2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(queue2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:     
                message2print = "{(Step 1Z10/70) yielded" + "; queue2commandqueue4qpu-yielded-by-flush2commandqueue4qpu: " + str(queue2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                
            if task4flush2commandqueue is None:
                pass
            else:
                # -------------------------------------------------------------------------------------
                # COMMAND QUEUE GIVEN AS PARAMETER          
                # -------------------------------------------------------------------------------------               
                queue2task = None    
                try:
                    queue2task = task4flush2commandqueue ['QUEUE']
                    message2print = "{(Step 1T/33) passed" + "; queue2task-passed-by-flush2commandqueue4qpu to: " + str(queue2task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #
                    
                    if queue2task == queue2commandqueue4qpu:
                        # -------------------------------------------------------------------------------------
                        # ACCEPTED - GIVEN COMMAND QUEUE IS THE SAME          
                        # -------------------------------------------------------------------------------------                     
                        message2print = "{(Step 1U/33) accepted" + "; queue2task-accepted-by-flush2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                    else:
                        message2print = "{(Step 1X/33) warned" + "; queue2task-warned-by-flush2commandqueue4qpu: " + " ** " + str(queue2task)  + " ** " + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        
                        message2print = "{(Step 1Y1/33) warned" + "; queue2commandqueue4qpu-warned-by-flush2commandqueue4qpu: " + " ** " + str(queue2commandqueue4qpu)  + " ** " + "; time: " + time4xi() + "}" 
                        print4xi(class2print, method2print, message2print)    
                        #                      
                except:     
                    message2print = "{(Step 1Z11/70) yielded" + "; queue2task-yielded-by-flush2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
            
            size2commandqueue4qpu = 0                             
            try:                    
                size2commandqueue4qpu = queue2commandqueue4qpu.qsize()
                message2print = "{(Step 1Y2/33) got" + "; size2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(size2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
            except:     
                message2print = "{(Step 1Z12/70) yielded" + "; size2commandqueue4qpu-yielded-by-flush2commandqueue4qpu: " + str(size2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
             
            empty2commandqueue4qpu = True          
            try:                    
                empty2commandqueue4qpu = queue2commandqueue4qpu.empty()
                message2print = "{(Step 1Y3/33) got" + "; empty2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(empty2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
            except:     
                message2print = "{(Step 1Z13/70) yielded" + "; qpu2xi-yielded-by-flush2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
             
            full2commandqueue4qpu = False          
            try:                                
                full2commandqueue4qpu= queue2commandqueue4qpu.full()
                message2print = "{(Step 1Y4/33) got" + "; full2commandqueue4qpu-got-by-flush2commandqueue4qpu to: " + str(full2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #                
            except:     
                message2print = "{(Step 1Z14/70) yielded" + "; full2commandqueue4qpu-yielded-by-flush2commandqueue4qpu: " + str(full2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                                                        
            message2print = "{(Step 1Y5/33) flushed" + "; qpu2commandqueue4xi-flushed-by-flush2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                    
        except:
            qpu2commandqueue4qpu= {}
            message2print = "{(Step 1Z15/70) yielded" + "; qpu2commandqueue4xi-yielded-by-flush2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; qpu2commandqueue4xi-returning-by-flush2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return qpu2commandqueue4xi
    
   
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "finish2commandqueue4qpu" usage = "
#   print('(Step 2A/33) OF QPU2COMMANDQUEUE4XI5TEST - TRYING TO CREATE COMMANDQUEUE4QPU ', time4xi())   
#   try:
#       cq2qpu = create2commandqueue4qpu()                                                                           
#       print('(Step 2B/33) OF QPU2COMMANDQUEUE4XI5TEST - CREATED COMMANDQUEUE4QPU: ', cq2qpu)                                  
#   except:
#       print('(Step 2Z/33) OF QPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE COMMANDQUEUE4QPU', time4xi()) 
#   ...
#   print('(Step 2B1/33) OF QPU2COMMANDQUEUE4XI5TEST - TRYING TO FINISH COMMANDQUEUE4QPU ', time4xi())      
#     
#   print('(Step 2B2/33) OF QPU2COMMANDQUEUE4XI5TEST - TRYING TO FINISH COMMANDQUEUE4QPU ', time4xi())      
#   #   
#   task4finish2commandqueue = cq2qpu
#   try:
#       finish2qpu = finish2commandqueue4qpu(task4finish2commandqueue)                                                     
#       print('(Step 2B2/33) OF QPU2COMMANDQUEUE4XI5TEST - FINISHED COMMANDQUEUE4QPU: ', finish2qpu)                                  
#       # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 
#       #  'SIZE2QUEUE': 2147483646, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 06:37:49 08/11/11 Pacific Daylight Time}',
#       #  'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}, 
#       #  'EMPTY2QUEUE': True, 'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x00000000036B4748>,
#       #  'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000037B3BE0>, 
#       #  'FULL2QUEUE': False, 
#       #  'STATE2QUEUE': (2147483647, <read-only PipeConnection, handle 240>, <write-only PipeConnection, handle 288>, <Lock(owner=None)>, None, <BoundedSemaphore4Xi(value=1, maxvalue=2147483647)>, 4248), 
#       #  'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 06:37:49 08/11/11 Pacific Daylight Time}',
#       #  'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x00000000036A5048>,
#       #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
#       #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
#       #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
#       #  'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
#       #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
#       #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write',
#       #  'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
#       #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
#       #  'VERSION2DRIVER': '2.0',
#       #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
#       #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
#       #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
#       #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
#       #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4,
#       #  'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024,
#       #  'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
#       #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8,
#       #  'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1,
#       #  'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
#       #  'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
#       #  'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 348>, <read-write PipeConnection, handle 352>)}; time: 06:37:49 08/11/11 Pacific Daylight Time}
#       
#   except:
#       print('(Step 2BZ/33) OF QPU2COMMANDQUEUE4XI5TEST *** FAILED TO FINISH COMMANDQUEUE4QPU', time4xi())     
#                          
#">

# -------------------------------------------------------------------------------------------------   
def finish2commandqueue4qpu(task4finish2commandqueue=None):

    '''
    finishes qpu2commandqueue4qpu
    '''
    
    global qpu2commandqueue4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "finish2commandqueue4qpu"
    method2print = "finish2commandqueue4qpu"

    message2print = "{(Step 1A1/33) started" + "; finish2commandqueue4qpu-started: " + str(finish2commandqueue4qpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
    message2print = "{(Step 1A2/33) passed" + "; task4finish2commandqueue-passed-by-finish2commandqueue4qpu to: " + str(task4finish2commandqueue)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
    try: 
        if qpu2commandqueue4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE - KEEP SYSTEM RUNNING           
            # -------------------------------------------------------------------------------------           
            qpu2commandqueue4xi = create2commandqueue4qpu()
            
            message2print = "{(Step 1B/33) created" + "; qpu2commandqueue4xi-created-by-finish2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
                                                
            # -------------------------------------------------------------------------------------
            # FINISH           
            # -------------------------------------------------------------------------------------             
            queue2commandqueue4qpu = None
            try:
                queue2commandqueue4qpu = qpu2commandqueue4xi['QUEUE']
                message2print = "{(Step 1C/33) got" + "; queue2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(queue2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:     
                message2print = "{(Step 1Z1/70) yielded" + "; qpu2xi-yielded-by-finish2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            size2commandqueue4qpu = 0
            try:                    
                size2commandqueue4qpu = queue2commandqueue4qpu.qsize()
                message2print = "{(Step 1D/33) got" + "; size2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(size2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
                               
                
            except:     
                message2print = "{(Step 1Z2/70) yielded" + "; qpu2xi-yielded-by-finish2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
             
            empty2commandqueue4qpu = True       
            try:                    
                empty2commandqueue4qpu= queue2commandqueue4qpu.empty()
                message2print = "{(Step 1E/33) got" + "; empty2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(empty2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
            except:     
                message2print = "{(Step 1Z3/70) yielded" + "; empty2commandqueue4qpu-yielded-by-finish2commandqueue4qpu: " + str(empty2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
             
            full2commandqueue4qpu = False       
            try:                                
                full2commandqueue4qpu = queue2commandqueue4qpu.full()
                message2print = "{(Step 1F/33) got" + "; full2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(full2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #                
            except:     
                message2print = "{(Step 1Z4/70) yielded" + "; full2commandqueue4qpu-yielded-by-finish2commandqueue4qpu: " + str(full2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)   
                            
            message2print = "{(Step 1G/33) finished" + "; qpu2commandqueue4xi-finished-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
                            
        else:
            # -------------------------------------------------------------------------------------
            # USE THE EXISTING COMMANDQUEUE FOR QPU          
            # -------------------------------------------------------------------------------------     
            
            message2print = "{(Step 1H/33) used" + "; qpu2commandqueue4xi-used-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            # -------------------------------------------------------------------------------------
            # FINISH           
            # -------------------------------------------------------------------------------------             
            queue2commandqueue4qpu = None
            try:
                queue2commandqueue4qpu = qpu2commandqueue4xi['QUEUE']
                message2print = "{(Step 1I/33) got" + "; queue2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(queue2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            except:     
                message2print = "{(Step 1Z5/70) yielded" + "; qpu2xi-yielded-by-finish2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                
            if task4finish2commandqueue is None:
                pass
            else:
                # -------------------------------------------------------------------------------------
                # COMMAND QUEUE GIVEN AS PARAMETER          
                # -------------------------------------------------------------------------------------               
                message2print = "{(Step 1J1/33) passed" + "; task4finish2commandqueue-passed-by-finish2commandqueue4qpu to: " + str(task4finish2commandqueue)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                queue2task = {}    
                try:
                    queue2task = task4finish2commandqueue ['QUEUE']
                    message2print = "{(Step 1J2/33) set" + "; queue2task-set-by-finish2commandqueue4qpu to: " + str(queue2task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                except:     
                    message2print = "{(Step 1Z61/70) yielded" + "; queue2task-yielded-by-finish2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                
                try:                        
                    if queue2task == queue2commandqueue4qpu:
                        # -------------------------------------------------------------------------------------
                        # ACCEPTED - GIVEN COMMAND QUEUE IS THE SAME          
                        # -------------------------------------------------------------------------------------                     
                        message2print = "{(Step 1K/33) accepted" + "; queue2task-accepted-by-finish2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                    else:
                        try:
                            message2print = "{(Step 1L/33) warned" + "; queue2task-warned-by-finish2commandqueue4qpu: " + " ** " + str(queue2task)  + " ** " + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # 
                        
                            message2print = "{(Step 1M/33) warned" + "; queue2commandqueue4qpu-warned-by-finish2commandqueue4qpu: " + " ** " + str(queue2commandqueue4qpu)  + " ** " + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)    
                            # 
                        except:
                            pass
                                                     
                except:     
                    message2print = "{(Step 1Z62/70) yielded" + "; queue2task-yielded-by-finish2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                   
            
            size2queue4qpu = 0        
            try:                    
                size2queue4qpu = queue2commandqueue4qpu.qsize()
                message2print = "{(Step 1N1/33) got" + "; size2queue4qpu-got-by-finish2commandqueue4qpu to: " + str(size2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                
                qpu2commandqueue4xi ['SIZE2QUEUE'] = size2queue4qpu
                message2print = "{(Step 1N2/33) set" + "; size2queue4commandqueue-got-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['SIZE2QUEUE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                  
                # 
            except:     
                message2print = "{(Step 1Z7/70) yielded" + "; size2queue4qpu-yielded-by-finish2commandqueue4qpu: " + str(size2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            empty2queue4qpu = False
            try:                    
                empty2queue4qpu = queue2commandqueue4qpu.empty()
                message2print = "{(Step 1O1/33) got" + "; empty2queue4qpu-got-by-finish2commandqueue4qpu to: " + str(empty2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                
                qpu2commandqueue4xi ['EMPTY2QUEUE'] = empty2queue4qpu
                message2print = "{(Step 1O2/33) set" + "; empty2queue4commandqueue-got-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['EMPTY2QUEUE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                   
            except:     
                message2print = "{(Step 1Z8/70) yielded" + "; empty2queue4qpu-yielded-by-finish2commandqueue4qpu: " + str(empty2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            full2queue4qpu = False
            try:                                
                full2queue4qpu = queue2commandqueue4qpu.full()
                message2print = "{(Step 1P1/33) got" + "; full2queue4qpu-got-by-finish2commandqueue4qpu to: " + str(full2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                 
                qpu2commandqueue4xi ['FULL2QUEUE'] = full2queue4qpu
                message2print = "{(Step 1P2/33) set" + "; full2queue4commandqueue-got-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['FULL2QUEUE'])  + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                #                            
            except:     
                message2print = "{(Step 1Z9/70) yielded" + "; full2queue4qpu-yielded-by-finish2commandqueue4qpu: " + str(full2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            
            state2queue4qpu = None
            try:                                
                state2queue4qpu = queue2commandqueue4qpu.__getstate__()
                message2print = "{(Step 1P3/33) got" + "; state2queue4qpu-got-by-finish2commandqueue4qpu to: " + str(state2queue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                # 
                 
                qpu2commandqueue4xi ['STATE2QUEUE'] = state2queue4qpu
                message2print = "{(Step 1P4/33) set" + "; state2queue4commandqueue-got-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi ['STATE2QUEUE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                              
            except:     
                message2print = "{(Step 1Z10/70) yielded" + "; state2queue4qpu-yielded-by-finish2commandqueue4qpu: " + str(state2queue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)               
                
                                                            
            message2print = "{(Step 1Q/33) finished" + "; qpu2commandqueue4xi-finished-by-finish2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            qpu2commandqueue4qpu = create2commandqueue4qpu()
            message2print = "{(Step 1R/33) got" + "; qpu2commandqueue4xi-got-by-finish2commandqueue4qpu to: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
            
            # -------------------------------------------------------------------------------------
            # FINISH           
            # -------------------------------------------------------------------------------------             
            queue2commandqueue4qpu = None
            try:
                queue2commandqueue4qpu = qpu2commandqueue4xi['QUEUE']
                message2print = "{(Step 1S/33) got" + "; queue2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(queue2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:     
                message2print = "{(Step 1Z10/70) yielded" + "; queue2commandqueue4qpu-yielded-by-finish2commandqueue4qpu: " + str(queue2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                
            if task4finish2commandqueue is None:
                pass
            else:
                # -------------------------------------------------------------------------------------
                # COMMAND QUEUE GIVEN AS PARAMETER          
                # -------------------------------------------------------------------------------------               
                queue2task = None    
                try:
                    queue2task = task4finish2commandqueue ['QUEUE']
                    message2print = "{(Step 1T/33) passed" + "; queue2task-passed-by-finish2commandqueue4qpu to: " + str(queue2task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #
                    
                    if queue2task == queue2commandqueue4qpu:
                        # -------------------------------------------------------------------------------------
                        # ACCEPTED - GIVEN COMMAND QUEUE IS THE SAME          
                        # -------------------------------------------------------------------------------------                     
                        message2print = "{(Step 1U/33) accepted" + "; queue2task-accepted-by-finish2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                    else:
                        message2print = "{(Step 1X/33) warned" + "; queue2task-warned-by-finish2commandqueue4qpu: " + " ** " + str(queue2task)  + " ** " + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        
                        message2print = "{(Step 1Y1/33) warned" + "; queue2commandqueue4qpu-warned-by-finish2commandqueue4qpu: " + " ** " + str(queue2commandqueue4qpu)  + " ** " + "; time: " + time4xi() + "}" 
                        print4xi(class2print, method2print, message2print)    
                        #                      
                except:     
                    message2print = "{(Step 1Z11/70) yielded" + "; queue2task-yielded-by-finish2commandqueue4qpu: " + str(queue2task) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
            
            size2commandqueue4qpu = 0                             
            try:                    
                size2commandqueue4qpu = queue2commandqueue4qpu.qsize()
                message2print = "{(Step 1Y2/33) got" + "; size2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(size2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
            except:     
                message2print = "{(Step 1Z12/70) yielded" + "; size2commandqueue4qpu-yielded-by-finish2commandqueue4qpu: " + str(size2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
             
            empty2commandqueue4qpu = True          
            try:                    
                empty2commandqueue4qpu = queue2commandqueue4qpu.empty()
                message2print = "{(Step 1Y3/33) got" + "; empty2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(empty2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #
            except:     
                message2print = "{(Step 1Z13/70) yielded" + "; qpu2xi-yielded-by-finish2commandqueue4qpu: " + str(qpu2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
             
            full2commandqueue4qpu = False          
            try:                                
                full2commandqueue4qpu= queue2commandqueue4qpu.full()
                message2print = "{(Step 1Y4/33) got" + "; full2commandqueue4qpu-got-by-finish2commandqueue4qpu to: " + str(full2commandqueue4qpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
                #                
            except:     
                message2print = "{(Step 1Z14/70) yielded" + "; full2commandqueue4qpu-yielded-by-finish2commandqueue4qpu: " + str(full2commandqueue4qpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                                                        
            message2print = "{(Step 1Y5/33) finished" + "; qpu2commandqueue4xi-finished-by-finish2commandqueue4qpu: " + str(qpu2commandqueue4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                    
        except:
            qpu2commandqueue4qpu= {}
            message2print = "{(Step 1Z15/70) yielded" + "; qpu2commandqueue4xi-yielded-by-finish2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; qpu2commandqueue4xi-returning-by-finish2commandqueue4qpu: " + str(qpu2commandqueue4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
   
    return qpu2commandqueue4xi
    
   
#</function4xi> 
                                               
# =================================================================================================
#<class4xi class = "QPU2CommandQueue4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for QPU commandqueue" usage = "CommandQueue4Xi of QPU"
#>

# =================================================================================================
class QPU2CommandQueue4Xi(object): 
    ''' 
    QPU2CommandQueue4Xi offers  methods for QPU commandqueue
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2qpu = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2qpu',
    'flush2qpu',
    'finish2qpu',    
    'get2qpu',
    'release2qpu',
    'retain2qpu',
    'set2qpu',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-QPU2CommandQueue4Xi" usage = "
    # try:
    #     # ---------------------------------------------------------------------------------------------
    #     # CREATE OBJECT                        
    #     # ---------------------------------------------------------------------------------------------        
    #     cc2xi = QPU2CommandQueue4Xi()
    #     print('(Step 5B/33) OF QPU4XI5TEST - CREATED QPU2CommandQueue4Xi OBJECT: ', cc2xi)                                       
    # except:
    #     print('(Step 5Z/33) OF QPU4XI5TEST *** FAILED TO CREATE QPU2CommandQueue4Xi OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2qpu = None):
        '''
        _init__ method initializes QPU2CommandQueue4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "QPU2CommandQueue4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 

        message2print = "{(Step 1B/33) borning" + "; qpu2commandqueue2xi-of-QPU2CommandQueue4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-qpu2commandqueue2xi-of-QPU2CommandQueue4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2qpu-sharing-by-qpu2commandqueue2xi-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi.classvariable2qpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2qpu-passed-to-init-of-QPU2CommandQueue4Xi: " + str(task4create2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2qpu-passing-to-create2commandqueue4qpu-by-init-of-QPU2CommandQueue4Xi: " + str(task4create2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
        
        qpu2commandqueue2xi = create2commandqueue4qpu(task4create2qpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2commandqueue4qpu-performed-by-init-of-QPU2CommandQueue4Xi: " + str(create2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; qpu2commandqueue2xi-of-QPU2CommandQueue4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-qpu2commandqueue2xi-of-QPU2CommandQueue4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2qpu-shared-by-qpu2commandqueue2xi-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi.classvariable2qpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #               
       
        message2print = "{(Step 3D/33) returning" + "; init-of-QPU2CommandQueue4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO CREATE QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.create2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - CREATED QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO CREATE QPU COMMANDQUEUE ***')
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2qpu(self, task4create2qpu = None):
        '''
        create2qpu method creates objects of QPU2CommandQueue4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "create2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; create2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4create2qpu-passed-to-create2qpu-of-QPU2CommandQueue4Xi: " + str(task4create2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2qpu-passing-to-create2commandqueue4qpu-by-create2qpu-of-QPU2CommandQueue4Xi: " + str(task4create2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        qpu2commandqueue2xi = create2commandqueue4qpu(task4create2qpu)

        message2print = "{(Step 2B/33) performed" + "; create2commandqueue4qpu-performed-by-create2qpu-of-QPU2CommandQueue4Xi: " + str(create2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; qpu2commandqueue2xi-returning-by-create2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
 
                
        return qpu2commandqueue2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2qpu-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO SET QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.set2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - SET QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO SET QPU COMMANDQUEUE ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2qpu(self, task4set2qpu = None):
        '''
        sets QPU2CommandQueue4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "set2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; set2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4set2qpu-passed-to-set2qpu-of-QPU2CommandQueue4Xi: " + str(task4set2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2qpu-passing-to-set2commandqueue4qpu-by-set2qpu-of-QPU2CommandQueue4Xi: " + str(task4set2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        qpu2commandqueue2xi = set2commandqueue4qpu(task4set2qpu)

        message2print = "{(Step 2B/33) performed" + "; set2commandqueue4qpu-performed-by-set2qpu-of-QPU2CommandQueue4Xi: " + str(set2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; qpu2commandqueue2xi-returning-by-set2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return qpu2commandqueue2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2qpu-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO GET QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.get2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - GOT QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO GET QPU COMMANDQUEUE ***')   
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2qpu(self):
        '''
        get2qpu method gets objects of QPU2CommandQueue4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "get2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; get2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        qpu2commandqueue2xi = get2commandqueueinfo4qpu()
        
        message2print = "{(Step 2A/33) returning" + "; qpu2commandqueue2xi-returning-by-get2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return qpu2commandqueue2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2qpu-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO SET QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.release2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - SET QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO SET QPU COMMANDQUEUE ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2qpu(self, task4release2qpu = None):
        '''
        releases QPU2CommandQueue4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "release2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; release2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4release2qpu-passed-to-release2qpu-of-QPU2CommandQueue4Xi: " + str(task4release2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2qpu-passing-to-release2commandqueue4qpu-by-release2qpu-of-QPU2CommandQueue4Xi: " + str(task4release2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        qpu2commandqueue2xi = release2commandqueue4qpu(task4release2qpu)

        message2print = "{(Step 2B/33) performed" + "; release2commandqueue4qpu-performed-by-release2qpu-of-QPU2CommandQueue4Xi: " + str(release2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; qpu2commandqueue2xi-returning-by-release2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return qpu2commandqueue2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2qpu-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO SET QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.retain2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - SET QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO SET QPU COMMANDQUEUE ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2qpu(self, task4retain2qpu = None):
        '''
        retains QPU2CommandQueue4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "retain2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; retain2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2qpu-passed-to-retain2qpu-of-QPU2CommandQueue4Xi: " + str(task4retain2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2qpu-passing-to-retain2commandqueue4qpu-by-retain2qpu-of-QPU2CommandQueue4Xi: " + str(task4retain2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        qpu2commandqueue2xi = retain2commandqueue4qpu(task4retain2qpu)

        message2print = "{(Step 2B/33) performed" + "; retain2commandqueue4qpu-performed-by-retain2qpu-of-QPU2CommandQueue4Xi: " + str(retain2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; qpu2commandqueue2xi-returning-by-retain2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return qpu2commandqueue2xi
                                                           
    #</methodize4xi>   
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "flush2qpu-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO FLUSH QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.flush2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - FLUSHED QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO FLUSH QPU COMMANDQUEUE ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def flush2qpu(self, task4flush2qpu = None):
        '''
        flushes QPU2CommandQueue4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "flush2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; flush2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4flush2qpu-passed-to-flush2qpu-of-QPU2CommandQueue4Xi: " + str(task4flush2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4flush2qpu-passing-to-flush2commandqueue4qpu-by-flush2qpu-of-QPU2CommandQueue4Xi: " + str(task4flush2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        qpu2commandqueue2xi = flush2commandqueue4qpu(task4flush2qpu)

        message2print = "{(Step 2B/33) performed" + "; flush2commandqueue4qpu-performed-by-flush2qpu-of-QPU2CommandQueue4Xi: " + str(flush2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)            
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; qpu2commandqueue2xi-returning-by-flush2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
           
        return qpu2commandqueue2xi
                                                           
    #</methodize4xi>       

    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "finish2qpu-of-QPU2CommandQueue4Xi" usage = "
    # print('(Step 1A/33) OF QPU2COMMANDQUEUE4XI - TRYING TO FINISH QPU COMMANDQUEUE')
    # try:
    #     cc2xi = QPU2CommandQueue4Xi()                            
    #     commandqueue2qpu = cc2xi.finish2qpu()                                  
    #     print('(Step 1B/33) OF QPU4XI5TEST - FINISHED QPU COMMANDQUEUE: ', commandqueue2qpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF QPU4XI5TEST *** FAILED TO FINISH QPU COMMANDQUEUE ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def finish2qpu(self, task4finish2qpu = None):
        '''
        finishes QPU2CommandQueue4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "QPU2CommandQueue4Xi"
        method2print = "finish2qpu"
                     
        message2print = "{(Step 1A/33) started" + "; finish2qpu-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4finish2qpu-passed-to-finish2qpu-of-QPU2CommandQueue4Xi: " + str(task4finish2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4finish2qpu-passing-to-finish2commandqueue4qpu-by-finish2qpu-of-QPU2CommandQueue4Xi: " + str(task4finish2qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        qpu2commandqueue2xi = finish2commandqueue4qpu(task4finish2qpu)

        message2print = "{(Step 2B/33) performed" + "; finish2commandqueue4qpu-performed-by-finish2qpu-of-QPU2CommandQueue4Xi: " + str(finish2commandqueue4qpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; qpu2commandqueue2xi-returning-by-finish2qpu-of-QPU2CommandQueue4Xi: " + str(qpu2commandqueue2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                    
                
        return qpu2commandqueue2xi
                                                            
    #</methodize4xi>
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-QPU2CommandQueue4Xi" usage = "
    # try:
    #     print(cc2xi.sense())
    # 
    #     print('=' *33)          
    #     print('(Step 15B/33) OF QPU4XI5TEST - SENSED ', time4xi())                                                  
    #                                                                                                                 
    #     print('=' *33)
    # except:
    #     print('(Step 15Z/33) OF QPU4XI5TEST *** FAILED TO SENSE ', time4xi())    
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses QPU2CommandQueue4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'QPU2CommandQueue4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; QPU2CommandQueue4Xi-sensing-by-sense-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-QPU2CommandQueue4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2qpu-of-QPU2CommandQueue4Xi'] = QPU2CommandQueue4Xi.classvariable2qpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-QPU2CommandQueue4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; QPU2CommandQueue4Xi-sensed-by-sense-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-QPU2CommandQueue4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                    
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-QPU2CommandQueue4Xi" usage = "
    # try:
    #     print(cc2xi.reason())
    # 
    #     print('=' *33)          
    #     print('(Step 17B/33) OF QPU4XI5TEST - REASONED ', time4xi())                                                
    #     print('=' *33)       
    # except:
    #     print('(Step 17Z/33) OF QPU4XI5TEST *** FAILED TO REASON ', time4xi())     
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons QPU2CommandQueue4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'QPU2CommandQueue4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; QPU2CommandQueue4Xi-reasoning-by-reason-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-QPU2CommandQueue4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-QPU2CommandQueue4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-QPU2CommandQueue4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; QPU2CommandQueue4Xi-reasoned-by-reason-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-QPU2CommandQueue4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                     
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-QPU2CommandQueue4Xi" usage = "
    # try:
    #     print(cc2xi.ace())
    # 
    #     print('=' *33)          
    #     print('(Step 21B/33) OF QPU4XI5TEST - ACED ', time4xi())                                                    
    #     print('=' *33) 
    # except:
    #     print('(Step 21Z/33) OF QPU4XI5TEST *** FAILED TO ACE ', time4xi())      
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces QPU2CommandQueue4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'QPU2CommandQueue4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-QPU2CommandQueue4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; QPU2CommandQueue4Xi-acing-by-ace-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-QPU2CommandQueue4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-QPU2CommandQueue4Xi'] = QPU2CommandQueue4Xi.classvariable2qpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-QPU2CommandQueue4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; QPU2CommandQueue4Xi-aced-by-ace-of-QPU2CommandQueue4Xi: " + str(QPU2CommandQueue4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-QPU2CommandQueue4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   qpu2commandqueue4xi5test.txt
#   sense-qpu2commandqueue4xi5test.xml
#   reason-qpu2commandqueue4xi5test.xml
#   ace-qpu2commandqueue4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>


#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of qpu2commandqueue4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
